#include "RegisterParty.hpp"
#include <CreatureLib/Battling/Models/BattleParty.hpp>
#include "../../../../Battling/Pokemon/PokemonParty.hpp"
#include "../HelperFile.hpp"

void RegisterParty::Register(asIScriptEngine* engine) {
    RegisterPartyClass(engine);
    RegisterBattleParty(engine);
}

static PkmnLib::Battling::Pokemon* GetAtIndexWrapper(PkmnLib::Battling::PokemonParty* obj, size_t i) {
    auto v = obj->GetAtIndex(i);
    if (v.HasValue()) {
        return v.GetValue();
    }
    return {};
}

void RegisterParty::RegisterPartyClass(asIScriptEngine* engine) {
    auto r = engine->RegisterObjectType("Party", 0, asOBJ_REF | asOBJ_NOCOUNT);
    Ensure(r >= 0);
    r = engine->RegisterObjectMethod("Party", "Pokemon@ GetAtIndex(int index) const", asFUNCTION(GetAtIndexWrapper),
                                     asCALL_CDECL_OBJFIRST);
    Ensure(r >= 0);
    r = engine->RegisterObjectMethod("Party", "int get_Length() const property",
                                     asMETHOD(PkmnLib::Battling::PokemonParty, GetLength), asCALL_THISCALL);
    Ensure(r >= 0);
}

void RegisterParty::RegisterBattleParty(asIScriptEngine* engine) {
    auto r = engine->RegisterObjectType("BattleParty", 0, asOBJ_REF | asOBJ_NOCOUNT);
    Ensure(r >= 0);
    r = engine->RegisterObjectMethod("BattleParty", "Party@ get_Party() const property",
                                     asMETHOD(CreatureLib::Battling::BattleParty, GetParty), asCALL_THISCALL);
    Ensure(r >= 0);
}
