#define BORROWED_PTR_GETTER_FUNC(o, returns, funcName)                                                                 \
    static returns* funcName##Wrapper(o* obj) { return obj->funcName().GetRaw(); }
#define OPTIONAL_BORROWED_PTR_GETTER_FUNC(o, returns, funcName)                                                        \
    static returns* funcName##Wrapper(o* obj) { return obj->funcName().GetValue(); }
#define UNIQUE_PTR_GETTER_FUNC(o, returns, funcName)                                                                   \
    static returns* funcName##Wrapper(o* obj) { return obj->funcName().get(); }

#define REGISTER_ENUM(enumName, asName)                                                                                \
    {                                                                                                                  \
        auto __r = engine->RegisterEnum(asName);                                                                       \
        Ensure(__r >= 0);                                                                                              \
        for (auto val : enumName##Helper::GetValues()) {                                                               \
            __r = engine->RegisterEnumValue(asName, enumName##Helper::ToString(val).c_str(), (i32)val);                \
            Ensure(__r >= 0);                                                                                          \
        }                                                                                                              \
    }
// Hack to handle AngelScript not recognizing different sized enums on fields, and returning invalid values due to it.
#define ENUM__SIZE_WRAPPER(name, type, func)                                                                           \
    int32_t name(type* obj) { return static_cast<int32_t>(obj->func()); }
